#include <stdlib.h>
#include <stdio.h>
#include <SDL2/SDL.h>
#include <SDL2/SDL_opengl.h>

int col;
int laufa = 0;
int v;
int st = 1;

void npUpdateAudio(void *userData, Uint8 *stream, int len)
{
	if (laufa==1) return;
	laufa=1;

	short* stream16 = (short*)stream;
	for(int i=0; i<(len/2); i++){
		stream[i] = v;
		v += st;
		if(v>65536) v= 0;
	}
	//((npAudio*)userData)->npProcessAudioChunk((unsigned char *)stream, len, (npAudio*)userData);
	laufa=0;
}

class Graphics
{
public:

    void update()
    {
        glClearColor(col % 255 / 255.0f, col % 255 / 255.0f, col % 255 / 255.0f, 1);
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
    }
};

int EventFilter(void* userdata, SDL_Event* event)
{
	col = rand();
    switch (event->type)
    {
        case SDL_KEYDOWN:
            SDL_Log("Key Down %d", event->key.keysym.sym);
            return 0;

        case SDL_KEYUP:
            SDL_Log("Key Up %d", event->key.keysym.sym);
            return 0;

        case SDL_MOUSEMOTION:
            SDL_Log("Mouse Moved. X=%d, Y=%d, RelativeX=%d, RelativeY=%d", event->motion.x, event->motion.y, event->motion.xrel, event->motion.yrel);
            return 0;

        case SDL_MOUSEBUTTONDOWN:
            SDL_Log("Mouse Button Down %d", event->button.button);
            return 0;

        case SDL_MOUSEBUTTONUP:
            SDL_Log("Mouse Button Up %d", event->button.button);
            return 0;

        case SDL_MOUSEWHEEL:
            SDL_Log("Mouse Wheel");
            return 0;
    }

    return 1;
}

int main(int argc, char * argv[])
{
    SDL_Window *window;
    SDL_Surface *surface;
    int width = 1080;
    int height = 720;
    int i;

    if (0 != SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER | SDL_INIT_AUDIO))
    {
        fprintf(stderr, "\nUnable to initialize SDL:  %s\n", SDL_GetError());
        return 0;
    }

    SDL_LogSetAllPriority(SDL_LOG_PRIORITY_VERBOSE);

    SDL_GL_SetAttribute(SDL_GL_CONTEXT_MAJOR_VERSION, 2);
    SDL_GL_SetAttribute(SDL_GL_CONTEXT_MINOR_VERSION, 0);
    SDL_GL_SetAttribute(SDL_GL_CONTEXT_PROFILE_MASK, SDL_GL_CONTEXT_PROFILE_ES);
    SDL_GL_SetAttribute(SDL_GL_ACCELERATED_VISUAL, 1);
    SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
//    SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE, 16);

    //Create the window
    window = SDL_CreateWindow("Rastline pojejo", 0, 0, width, height, SDL_WINDOW_OPENGL | SDL_WINDOW_SHOWN);

    if (window == 0)
    {
        SDL_Quit();
        return false;
    }

    SDL_GLContext gl = SDL_GL_CreateContext(window);

    SDL_AddEventWatch(EventFilter, 0);

    Graphics* graphics = new Graphics();

	SDL_AudioSpec audiospec;

	audiospec.freq=44100;
	audiospec.format=AUDIO_S16;
	audiospec.samples=128;//2048;//-1024;
	audiospec.channels=2;
	audiospec.callback=npUpdateAudio;

//	audiospec.userdata = script;
//*
	if((i=SDL_OpenAudio(&audiospec, NULL))!=0) {
		fprintf(stderr, "\nSDL_OpenAudio failed");
		exit(1);
	}
	printf("Freq: %d\n", audiospec.freq);
	printf("format: %d\n", audiospec.format);
	printf("samples: %d\n", audiospec.samples);
	printf("channels: %d\n", audiospec.channels);

	SDL_PauseAudio(0);

    //Game Loop
    SDL_Event event;
    bool done = false;
    while (!done)
    {
        SDL_PumpEvents();
        while (SDL_PollEvent(&event))
        {
            switch (event.type)
            {
                case SDL_QUIT:
                    done = true;
                    break;

                case SDL_APP_DIDENTERFOREGROUND:
                    SDL_Log("SDL_APP_DIDENTERFOREGROUND");
                    break;

                case SDL_APP_DIDENTERBACKGROUND:
                    SDL_Log("SDL_APP_DIDENTERBACKGROUND");
                    break;

                case SDL_APP_LOWMEMORY:
                    SDL_Log("SDL_APP_LOWMEMORY");
                    break;

                case SDL_APP_TERMINATING:
                    SDL_Log("SDL_APP_TERMINATING");
                    break;

                case SDL_APP_WILLENTERBACKGROUND:
                    SDL_Log("SDL_APP_WILLENTERBACKGROUND");
                    break;

                case SDL_APP_WILLENTERFOREGROUND:
                    SDL_Log("SDL_APP_WILLENTERFOREGROUND");
                    break;

                case SDL_WINDOWEVENT:
                {
                    switch (event.window.event)
                    {
                        case SDL_WINDOWEVENT_SHOWN:
                            SDL_Log("Window %d shown", event.window.windowID);
                            break;
                        case SDL_WINDOWEVENT_HIDDEN:
                            SDL_Log("Window %d hidden", event.window.windowID);
                            break;
                        case SDL_WINDOWEVENT_EXPOSED:
                            SDL_Log("Window %d exposed", event.window.windowID);
                            break;
                        case SDL_WINDOWEVENT_MOVED:
                            SDL_Log("Window %d moved to %d,%d", event.window.windowID, event.window.data1, event.window.data2);
                            break;
                        case SDL_WINDOWEVENT_RESIZED:
                            SDL_Log("Window %d resized to %dx%d", event.window.windowID, event.window.data1, event.window.data2);
                            break;
                        case SDL_WINDOWEVENT_MINIMIZED:
                            SDL_Log("Window %d minimized", event.window.windowID);
                            break;
                        case SDL_WINDOWEVENT_MAXIMIZED:
                            SDL_Log("Window %d maximized", event.window.windowID);
                            break;
                        case SDL_WINDOWEVENT_RESTORED:
                            SDL_Log("Window %d restored", event.window.windowID);
                            break;
                        case SDL_WINDOWEVENT_ENTER:
                            SDL_Log("Mouse entered window %d", event.window.windowID);
                            break;
                        case SDL_WINDOWEVENT_LEAVE:
                            SDL_Log("Mouse left window %d", event.window.windowID);
                            break;
                        case SDL_WINDOWEVENT_FOCUS_GAINED:
                            SDL_Log("Window %d gained keyboard focus", event.window.windowID);
                            break;
                        case SDL_WINDOWEVENT_FOCUS_LOST:
                            SDL_Log("Window %d lost keyboard focus", event.window.windowID);
                            break;
                        case SDL_WINDOWEVENT_CLOSE:
                            SDL_Log("Window %d closed", event.window.windowID);
                            break;
                        default:
                            SDL_Log("Window %d got unknown event %d", event.window.windowID, event.window.event);
                            break;
                    }

                    break;
                }
            }
        }

        graphics->update();
        SDL_GL_SwapWindow(window);
    }

    SDL_GL_DeleteContext(gl);

    // Done! Close the window, clean-up and exit the program.
    SDL_DestroyWindow(window);
    SDL_Quit();
}
